Package org.eclipse.viatra.query.runtime.matchers.backend

## Interface IQueryBackendFactoryProvider

- All Known Implementing Classes:
    `LocalSearchBackendFactoryProvider`, `LocalSearchGenericBackendFactoryProvider`, `ReteBackendFactoryProvider`

      public interface IQueryBackendFactoryProvider

  A provider interface for `IQueryBackendFactory` instances.
  Since:
    2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `IQueryBackendFactory` | `getFactory()` | Returns a query backend factory instance.
    `default boolean` | `isSystemDefaultCachingBackend()` | Returns whether the given query backend should be considered as system default caching backend.
    `default boolean` | `isSystemDefaultEngine()` | Returns whether the given query backend should be considered as system default.
    `default boolean` | `isSystemDefaultSearchBackend()` | Returns whether the given query backend should be considered as system default search backend.

- - ### Method Detail

    - #### getFactory

          IQueryBackendFactory getFactory()

      Returns a query backend factory instance. The method should return the same instance in case of repeated calls.

    - #### isSystemDefaultEngine

          default boolean isSystemDefaultEngine()

      Returns whether the given query backend should be considered as system default. If multiple backends are registered as system default, it is undefined which one will be chosen.

    - #### isSystemDefaultSearchBackend

          default boolean isSystemDefaultSearchBackend()

      Returns whether the given query backend should be considered as system default search backend. If multiple backends are registered as system default, it is undefined which one will be chosen.

    - #### isSystemDefaultCachingBackend

          default boolean isSystemDefaultCachingBackend()

      Returns whether the given query backend should be considered as system default caching backend. If multiple backends are registered as system default, it is undefined which one will be chosen.